#ifndef _FLIB_PROTOCOL_H_
#define _FLIB_PROTOCOL_H_

#include "flib.h"
#include "flib_logging_protocol.h"

void cm_process_notifications();

int* take_demand_checkpoint(int requesting_rank);

void handle_cp_demand_put_checkpoint_request();
void handle_cp_demand_put_checkpoint_done();
void handle_cp_demand_get_checkpoint_request();
void handle_cp_demand_get_checkpoint_done();
void handle_cp_necessary_checkpoint_done();
void handle_cp_global_recovery_request();
void handle_unknown_request_cm(int tag);

void start_cp_coordinated_checkpoint_request();
void check_for_coordinated_checkpoint_finalization();
void finalize_coordinated_checkpoint(int faked);
void cm_measure_frequency_of_coordinated_checkpoints();
void cm_manage_coordinated_checkpoint();
void cm_manage_BSP_simple_coordinated_checkpoint();
void cm_begin_BSP_distributed_coordinated_checkpoint();
void cm_manage_BSP_distributed_coordinated_checkpoint();
void cm_manage_degeneration();
void cm_manage_global_recovery();
void cm_manage_recomputing_coordinated_checkpoint_frequency();

void take_coordinated_checkpoint(int faked);
void inc_coord_counter();
void flush_all_communication_channels();

void __handle_cm_global_logs_cleared();

#endif
