#ifndef _FLIB_CP_PROC_H
#define _FLIB_CP_PROC_H

#include "flib.h"

void cp_process_notifications();

void cp_manage_coordinated_checkpoint(int* cm_procs_done);
void send_cp_master_coordinated_checkpoint_request();
void send_cp_coordinated_checkpoint_request();
void handle_cp_master_coordinated_checkpoint_request(int* cm_procs_done);
void wait_for_coordinated_checkpoints(int* cm_procs_done);
void handle_simple_bsp_coordinated_checkpoint(int faked);
void handle_cp_master_global_recovery_request();

void send_cp_master_notification(int tag);
void send_cp_notification_to_assigned_cms(int tag);
void wait_for_cm_global_recovery_confirmations();
void fall_back_to_previous_checkpoint();

void handle_cm_demand_put_checkpoint_request();
void handle_cm_demand_put_checkpoint_done();
void handle_cm_demand_get_checkpoint_request();
void handle_cm_demand_get_checkpoint_done();
void handle_cm_necessary_checkpoint_done();
void handle_cm_global_logs_cleared();

void handle_proc_error();
void handle_proc_recovery();
void handle_quit(int* procs_nr);
int handle_unknown_request_cp(int tag);

int is_our_proc(int rank, int communicator_type);

#endif
