#include "flib_debug.h"

void debug_message_gen_e(int fail, FILE* stream, const char* format) {
	char msg[1024];
	if(cm_proc()) {
		sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
    fprintf(stream, strcat(msg, format));
	}
	else {
		sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
    fprintf(stream, strcat(msg, format));
	}
	if(fail == TRUE) {
		exit(EXIT_FAILURE);
	}
}

void debug_message_gen(int fail, FILE* stream, const char* format, ...) {
	char msg[1024];
	char cnt[1024];

	va_list args;
  va_start(args, format);
	vsprintf(cnt,format,args);
	va_end(args);

	if(cm_proc()) {
		sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
    fprintf(stream, strcat(msg, cnt));
	}
	else {
		sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
    fprintf(stream, strcat(msg, cnt));
	}
	if(fail == TRUE) {
		exit(EXIT_FAILURE);
	}
}

void debug_message_e(int proc_to_speak, int fail, FILE* stream, const char* format) {
	char msg[1024];

	if(proc_to_speak == _FLIB_FIRST_IN_INITIAL) {
    if((*desc)->initial_user_rank == 0) {
			if(cm_proc()) {
				sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, format));
			}
			else {
				sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, format));
			}
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_FLIB_CM) {
    if((*desc)->flib_level_rank == 0 && cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
      fprintf(stream, strcat(msg, format));
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_FLIB_CP) {
    if((*desc)->flib_level_rank == 0 && cp_proc()) {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
      fprintf(stream, strcat(msg, format));
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_NODE) {
    if((*desc)->node_level_rank == 0) {
			if(cm_proc()) {
				sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, format));
			}
			else {
				sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, format));
			}
    }
  }
  else if(proc_to_speak == _FLIB_ANY_IN_INITIAL) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
		else {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
	} 
  else if(proc_to_speak == _FLIB_ANY_IN_FLIB_CM) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
	}
  else if(proc_to_speak == _FLIB_ANY_IN_FLIB_CP) {
 		if(cp_proc()) {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
	}
  else if(proc_to_speak == _FLIB_ANY_IN_NODE) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
		else {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, format));
		}
	}

	if(fail == TRUE) {
		exit(EXIT_FAILURE);
	}
}

void debug_message(int proc_to_speak, int fail, FILE* stream, const char* format, ...) {
	char msg[1024];
	char cnt[1024];

	va_list args;
  va_start(args, format);
	vsprintf(cnt,format,args);
	va_end(args);

  if(proc_to_speak == _FLIB_FIRST_IN_INITIAL) {
    if((*desc)->initial_user_rank == 0) {
			if(cm_proc()) {
				sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, cnt));
			}
			else {
				sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, cnt));
			}
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_FLIB_CM) {
    if((*desc)->flib_level_rank == 0 && cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
      fprintf(stream, strcat(msg, cnt));
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_FLIB_CP) {
    if((*desc)->flib_level_rank == 0 && cp_proc()) {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
      fprintf(stream, strcat(msg, cnt));
    }
  }
  else if(proc_to_speak == _FLIB_FIRST_IN_NODE) {
    if((*desc)->node_level_rank == 0) {
			if(cm_proc()) {
				sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, cnt));
			}
			else {
				sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	    fprintf(stream, strcat(msg, cnt));
			}
    }
  }
  else if(proc_to_speak == _FLIB_ANY_IN_INITIAL) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
		else {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
  } 
  else if(proc_to_speak == _FLIB_ANY_IN_FLIB_CM) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
  }
  else if(proc_to_speak == _FLIB_ANY_IN_FLIB_CP) {
		if(cp_proc()) {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
  }
  else if(proc_to_speak == _FLIB_ANY_IN_NODE) {
		if(cm_proc()) {
			sprintf(msg,"[%i,IN|%i,CM|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
		else {
			sprintf(msg,"[%i,IN|%i,CP|%i,ND] ",(*desc)->initial_user_rank,(*desc)->flib_level_rank,(*desc)->node_level_rank);
  	  fprintf(stream, strcat(msg, cnt));
		}
  }

	if(fail == TRUE) {
    exit(EXIT_FAILURE);
  }
}
