#ifndef _GROUPS_H_
#define _GROUPS_H_

#include "flib.h"
#include "flib_debug.h"

int get_rank(MPI_Comm comm);
int get_initial_user_rank();

void print_comm_size(MPI_Comm* comm);

int assigned_cp_proc(int cm_proc_rank);  // get world rank of assigned cp proc
int my_assigned_cp_proc();
int* assigned_cm_procs();
int assigned_cm_procs_nr();

int get_size(MPI_Comm comm);
int get_initial_user_size();

int* get_cp_procs_ranks();

int get_groups_nr(int cp_procs);
int get_group_size(int cp_procs);
int get_cm_procs_nr(int cp_procs);

void divide_into_nodes_scheme(int cp_procs, MPI_Comm initial_comm, MPI_Comm* flib_level_comm);
void divide_into_simple_scheme(int cp_procs, MPI_Comm initial_comm, MPI_Comm* flib_level_comm);
void divide_into_groups(int hierarchy_scheme, int cp_procs, MPI_Comm initial_comm, MPI_Comm* flib_level_comm);

int translate_from_flib_to_world_rank(int flib_rank);
int translate_from_world_to_flib_rank(int world_rank);

int is_first_cp_process();
int first_cp_proc(int rank);

int is_first_cm_process();
int first_cm_proc(int rank);

int get_first_cm_process_flib_rank();

void __test_number_of_comms();

#endif
