#ifndef _FLIB_TESTS_H_
#define _FLIB_TESTS_H_

#include "flib.h"
#include "flib_tests_internal.h"
#include "flib_cp_proc.h"

void __test_groups_division();
void __test_initial_checkpoint();
void __test_checkpoint(int origin_rank);

void __init_logging_testing();
void __init_puts_logging();
void __init_gets_logging();

void __log_put( const void *origin_addr, int origin_count, MPI_Datatype origin_datatype, int target_rank, MPI_Aint target_disp, int target_count, MPI_Datatype target_datatype,
								MPI_Op operation, Operation_type op_type, int verbose);
void __log_get( const void *origin_addr, int origin_count, MPI_Datatype origin_datatype, int target_rank, MPI_Aint target_disp, int target_count, MPI_Datatype target_datatype, int epoch_nr, int verbose);
void __log_accumulate( const void *origin_addr, int origin_count, MPI_Datatype origin_datatype, int target_rank, MPI_Aint target_disp, int target_count, MPI_Datatype target_datatype, MPI_Op operation, int verbose);

void __test_consistency_of_puts(int verbose);
void __test_consistency_of_gets(int verbose);

void __print_gets();
//void __test_all_logs_of_gets(int verbose);

void __delete_put_testing_logs(int rank_to_clear, int epoch_to_clear, int verbose);
void __delete_get_testing_logs(int rank_to_clear, int epoch_to_clear, int verbose);

void __delete_all_testing_logs();
void __delete_all_put_testing_logs();
void __delete_all_get_testing_logs();

void __finalize_logging_testing();

#endif
