#include "flib.h"
#include "flib_cm_proc.h"
#include "flib_recovery.h"

//#######################################################################################################################################
//Routines that enable the user to get some parameters
//#######################################################################################################################################

double fLIB_get_daly_interval() {
  return (*desc)->daly_interval;
}

int fLIB_get_user_rank() {
  assert(*desc != NULL);
  return (*desc)->flib_level_rank;
}

int fLIB_get_user_size() {
  assert(*desc != NULL);
  return (*desc)->cm_size;
}

//#######################################################################################################################################
//A function that takes an ordered checkpoint at the time specified by the user
//#######################################################################################################################################

void fLIB_take_ordered_coordinated_checkpoint() {
	(*desc)->coordinated_checkpoint_started = TRUE;
	int faked = FALSE;
  finalize_coordinated_checkpoint(faked);
	(*desc)->coordinated_checkpoint_started = FALSE;
}

//#######################################################################################################################################
//A function 'recover me' that is called by a crashed process. In a recovery that involves active participation of all other procs.
//#######################################################################################################################################

void fLIB_global_recovery() {
	cm_global_recovery();
}

void _fLIB_handle_cp_global_recovery_request() {
	handle_cp_global_recovery_request();
}

void _fLIB_cm_manage_global_recovery() {
	cm_manage_global_recovery();
}

//#######################################################################################################################################
//A function 'recover me' that is called by a crashed process. In a recovery that does NOT involve active participation of all other procs.
//#######################################################################################################################################

void fLIB_local_recovery() {
	cm_local_recovery();
}

