#ifndef _FLIB_WIN_CREATE_H_
#define _FLIB_WIN_CREATE_H_

#include "flib.h"
#include "flib_logging_protocol.h"

void init_timing(double mtbf);
void calculate_daly_interval(double mtbf);
void start_timing();

void init_flib_desc(int hierarchy, int protocol_type, int log_puts, int log_gets, int log_list_size);

void init_cm_descriptor();
void init_cp_descriptor();

void init_checkpoint_window(MPI_Aint app_data_size);
void init_cm_windows(foMPI_Win* app_win);
void init_marker_windows();
void init_counters();
void init_epoch_window();
void init_logging_space();

void take_initial_checkpoint();

void initiate_coordinated_checkpointing();
void initiate_global_recovery_protocol();

int initialize_window(const char* creation_type, void *base, MPI_Aint size, int disp_unit, MPI_Info info, MPI_Comm comm, foMPI_Win *win, int cp_procs,
                      MPI_Comm* user_comm, int hierarchy, double mtbf, int protocol_type, int log_puts, int log_gets, int log_list_size);

void print_flib_parameters();
void take_daly_measurement_checkpoint();

#endif
