#ifndef _HTOR_COMMON_H_
#define _HTOR_COMMON_H_

#include <stdlib.h>
#include <unistd.h>
#include <math.h>
//#include "mt64.h"
#include "mt19937-64.h"
#include "./hrtimer/hrtimer.h"

//confs:
//max avg cols: 4, fill ratio: 0.05, ttl: 3 == 2.46 % of cols
//max avg cols: 4, fill ratio: 0.05, ttl: 6 == 2.46 % of cols
//max avg cols: 4, fill ratio: 0.05, ttl: 3 == 2.46 % of cols
//max avg cols: 4, fill ratio: 0.05, ttl: 3 == 2.46 % of cols

#define MAX_AVG_COLLISIONS 4
#define HTABLE_FILL_RATIO 0.05

void wait_rand_time();

int64_t bigRandVal() {
	/*  int64_t val = rand();
			val <<= 31;
			val += rand();
			return val;*/

	int64_t random = 
		(((int64_t) rand() <<  0) & 0x000000000000FFFFll) | 
		(((int64_t) rand() << 16) & 0x00000000FFFF0000ll) | 
		(((int64_t) rand() << 32) & 0x0000FFFF00000000ll) |
		(((int64_t) rand() << 48) & 0x0FFF000000000000ll);
	return random;
}

HRT_TIMESTAMP_T c1, c2;
uint64_t cs;
double comp_time = 0;

int iters = -1;
timespec sleepValue = {0};
bool warmup = true;

void local_computation() {                                                                                                                                                         
	HRT_GET_TIMESTAMP(c1);

	wait_rand_time();

	/*int k = 0;
		for(int i = 0; i < iters; i++) {
		for(int kk = 0; kk < 1; kk++) {
		k = sin(i) * cos(kk) / (double)123 * kk / 127 + rand() % 10000;
		}
		}*/

	//////parameters for double insert
	//////for N=16 gives 12% of overhead
	//double rand_nr = (abs(rand()) % 20 + 1);
	//double delta = 1;
	//double scale = 10000;
	//double wait_time = scale*delta*exp(-1*delta*(rand_nr));

	//double rand_nr = (abs(rand()) % 2000 + 1);
	//double delta = 1;
	//double scale = 10;
	//double wait_time = scale*delta*exp(-1*delta*(rand_nr));

	//usleep(wait_time);  
	//nanosleep(wait_time*100);
	//sleepValue.tv_nsec = wait_time;
	//sleepValue.tv_nsec = 1;
	//nanosleep(&sleepValue, NULL);

	HRT_GET_TIMESTAMP(c2);
	HRT_GET_ELAPSED_TICKS(c1, c2, &cs);
	if(warmup == false) {comp_time += HRT_GET_USEC(cs);}
}

void wait_rand_time() {
	if(iters <= 0) {
		int delta = 1;
		/////gives 12% for N=16, with ratio 10%
		int f = 800;
		double rand_val = rand() % 1000;
		double x = (double)(rand_val) / (double)(rand_val*1000 + 1);
		int cnt = (int)(f*delta*exp(-1*delta*x));
	}
	else {
		int cnt=iters;

		int k = 0;
		for(int i = 0; i < cnt; i++) {
			for(int kk = 0; kk < 1; kk++) {
				k = sin(i) * cos(kk) / (double)123 * kk / 127 + rand() % 10000;
			}
		}
	}
}

#endif
